import os
from os import listdir
from os.path import isdir, join
from re import match
import sys
import shutil

from shutil import copyfile


# Add this to vs 2019:
# https://marketplace.visualstudio.com/items?itemName=MaciejGudanowicz.AddMultipleProjectsToSolution
# Run this script in old solution directory Open new solution Add all projects to
# solution


def fast_scandir(dirname):
    subfolders = [f.path for f in os.scandir(dirname) if f.is_dir() and f.path.find(".git")<0]
    for dirname in list(subfolders):
        if dirname.find(".git") < 0:
            subfolders.extend(fast_scandir(dirname))
    return subfolders


def deldirs():
    subfolders = fast_scandir('.')
    for d in subfolders:
        deldir = False
        if 'Test' in d:
            deldir = True
        if '\\bin' in d:
            deldir = True
        if '\\obj' in d:
            deldir = True
        if '\\Properties' in d:
            deldir = True
        if deldir:
            # noinspection PyBroadException
            try:
                shutil.rmtree(d)
                print('Delete', d)
            except Exception:
                pass

def copy_projfile(empty_proj_file_name, text, new_proj_file_name):
    with open(empty_proj_file_name) as f:
        proj = f.read()
    # print(text, proj)
    lines = text.split("\n")
    content = ""
    for line in lines:
        if not '<Content' in line:
            continue
        line = line.replace("<Content Include=", "    <None Update=").replace(" />",">")
        line = line + "\n            <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>\n        </None>\n"
        content += line

    # print(content)
    proj = proj.replace("XXXXXX", content)
    # print(proj)
    with open(new_proj_file_name, 'w') as f:
        f.write(proj)


def change(datadir):
    deldirs()
    onlydirs = fast_scandir('.')
    for d in onlydirs:
        projs = [d + '/' + f for f in listdir(d) if match(r'.*csproj', f)]
        if projs:
            proj_type = ''
            proj_file_name = projs[0]
            proj_name = os.path.basename(proj_file_name).replace('.csproj', '')
            with open(proj_file_name) as pf:
                text = pf.read()
                oldtext = text
                text = text.replace("<TargetFrameworks>netcoreapp3.1</TargetFrameworks>", "<TargetFramework>net5.0</TargetFramework>")
                text = text.replace('<TargetFramework>netcoreapp3.1</TargetFramework>', '<TargetFramework>net5.0</TargetFramework>')
                text = text.replace('<PackageReference Include="Jypeli.Core" Version="9.*" />', '<PackageReference Include="Jypeli.NET" Version="10.*" />')
                text = text.replace('<PackageReference Include="Jypeli.Physics2d.Core" Version="1.5.*" />', '<PackageReference Include="Jypeli.FarseerPhysics.NET" Version="1.0.*" />')
            if oldtext != text:
                print(proj_file_name)
                print("============================")
                print(text)
                with open(proj_file_name, 'w') as f:
                    f.write(text)
"""
    slns = [f for f in listdir('.') if match(r'.*sln', f)]
    if slns:
        print(slns[0])
        copyfile(datadir + '\\' + 'empty.sln', slns[0])
"""

# Press the green button in the gutter to run the script.
if __name__ == '__main__':
    ddir = os.path.dirname(os.path.realpath(sys.argv[0]))  # os.path.dirname(os.path.realpath(__file__))
    change(ddir)

# See PyCharm help at https://www.jetbrains.com/help/pycharm/
